/* $egnet: storage.h,v 1.6 2005/03/20 06:15:13 dive Exp $ */

/******************************************************************************
  Copyright (c) 1992, 1995, 1996 Xerox Corporation.  All rights reserved.
  Portions of this code were written by Stephen White, aka ghond.
  Use and copying of this software and preparation of derivative works based
  upon this software are permitted.  Any distribution of this software or
  derivative works must comply with all applicable United States export
  control laws.  This software is made available AS IS, and Xerox Corporation
  makes no warranty about the software, its performance or its conformity to
  any specification.  Any person obtaining a copy of this software is requested
  to send their name and post office or electronic mail address to:
    Pavel Curtis
    Xerox PARC
    3333 Coyote Hill Rd.
    Palo Alto, CA 94304
    Pavel@Xerox.Com
 *****************************************************************************/

#ifndef Storage_h
#define Storage_h 1

#include "config.h"
#include "structures.h"
#include "ref_count.h"

typedef enum Memory_Type {
	M_AST_POOL, M_AST, M_PROGRAM, M_PVAL, M_NETWORK, M_STRING, M_VERBDEF,
	M_LIST, M_PREP, M_PROPDEF, M_OBJECT_TABLE, M_OBJECT, M_FLOAT,
	M_STREAM, M_NAMES, M_ENV, M_TASK, M_PATTERN,

	M_BYTECODES, M_FORK_VECTORS, M_LIT_LIST,
	M_PROTOTYPE, M_CODE_GEN, M_DISASSEMBLE, M_DECOMPILE,

	M_RT_STACK, M_RT_ENV, M_BI_FUNC_DATA, M_VM,

	M_REF_ENTRY, M_REF_TABLE, M_VC_ENTRY, M_VC_TABLE, M_STRING_PTRS,
	M_INTERN_POINTER, M_INTERN_ENTRY, M_INTERN_HUNK,

	Sizeof_Memory_Type

}               Memory_Type;

extern char    *str_dup(const char *);
extern const char *str_ref(const char *);
extern Var      memory_usage(void);

extern void     myfree(void *where, Memory_Type type);
extern void    *mymalloc(unsigned size, Memory_Type type);
extern void    *myrealloc(void *where, unsigned size, Memory_Type type);

static inline void		/* XXX was extern, fix for non-gcc compilers */
free_str(const char *s)
{
	if (delref(s) == 0)
		myfree((void *) s, M_STRING);
}

#endif				/* Storage_h */
